﻿# codage de la liste des réactifs et des produits, chaque espèce chimique
# étant une liste comportant le nom, le coefficient stoechiométrique et
# la quantité de matière initiale de l'espèce
#
# des fonctions permettent de récupérer le nom, le coefficient
# stoechimétrique et la quantité de matière pour chaque espece
#
# On écrit une fonction permettant d'afficher l'équation bilan
#
# On écrit une fonction pour calculer l'avancement maximal x_max
#
# On écrit une fonction qui calcule l'état du système à l'avancement x


liste_reactifs = [
                    [ 'CH4' , 1 , 0.54 ],
                    [ 'O2'  , 2 , 0.54 ]
                ]

liste_produits = [
                    [ 'H2O' , 2 , 0.01 ],
                    [ 'CO2' , 1 , 0.0 ]
                ]


def getNom(reactif):
    return reactif[0]

def getCoef(reactif):
    return reactif[1]

def getQte(reactif):
    return reactif[2]

def afficherEquation():
    # chaine de caractère qui sera affichée, vide au début
    equation = ""
    # On parcoure la liste des réactifs, pour récupérer le numéro du réactif
    # en commençant à 1, et le réactif (role de enumerate)
    for i , reactif in enumerate(liste_reactifs, 1):
        equation = equation + str(getCoef(reactif)) + ' ' + getNom(reactif)
        # si le réactif n'est pas le dernier dans la liste , on ajoute +
        if i < len(liste_reactifs):
            equation = equation + ' + '
    # on dessine la flêche de la réaction
    equation = equation + ' --------> '
    # on ajoute la partie des produits
    for i , produit in enumerate(liste_produits, 1):
        equation = equation + str(getCoef(produit)) + ' ' + getNom(produit)
        # si le produit n'est pas le dernier dans la liste , on ajoute +
        if i < len(liste_produits):
            equation = equation + ' + '
    return equation #la chaîne de caractère contient l'équation bilan


def calculerXmax():
    # on va calculer pour chaque réactif la valeur de x pour
    # laquelle il disparait et on stocke cette valeur dans une liste
    solutions_possibles = []
    for reactif in liste_reactifs:
        x = getQte( reactif ) / getCoef( reactif )
        # on ajoute le résultat à la liste des solutions mathématiques
        solutions_possibles.append(x)
    # xmax est la plus petite valeur des solutions disponibles
    xmax = min(solutions_possibles)
    return xmax


def calculerEtat(x):
    # on stocke des valeurs des quantités de matière dans une liste
    liste_qte = []
    for reactif in liste_reactifs:
        qte = getQte( reactif ) - getCoef( reactif ) * x
        liste_qte.append( qte )
    for produit in liste_produits:
        qte = getQte( produit ) + getCoef( produit ) * x
        liste_qte.append( qte )
    return liste_qte


# test de la fonction
x_max =  calculerXmax()
print( x_max)
print(calculerEtat( x_max / 2 ))
print(calculerEtat( x_max ))